///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//
#pragma once

#include "..\src\libLASeR\LASeR.h"
#include "..\src\libLASeR\SAF.h"
#include "..\src\XML2SceneTree\XMLFileManager.h"

#include <deque>


class CBitstreamWriter
{
protected:
	deque<UINT8>	m_auBitstream;
	deque<UINT8>	m_auTemp;

	UINT8			m_uUsedBits;
	UINT8			m_uBuffer;

	UINT16			m_uPacketSeqNum;

public:
	CBitstreamWriter();
	~CBitstreamWriter();

	lsrErr	GetRealNodeType(CLASeR *pLASeRNode, CSAF *pSAFNode);

protected:
	lsrErr	Encode(CSceneHeader *pSceneHeader);

	void	EncodeSAFPacketHeader(const UINT8 bRap, const UINT uTime, const UINT16 uLength);
	UINT8	GetSAFType(const UINT8 uSAFType);

	void	Write8(const UINT8 uValue, UINT8 uFlag = 0);
	void	Write16(const UINT16 uValue, UINT8 uFlag = 0);
	void	Write24(const UINT uValue, UINT8 uFlag = 0);
	void	Write32(const UINT uValue, UINT8 uFlag = 0);
	void	WriteBits(const UINT uBits, const UINT uValue, UINT8 uFlag = 0);

	void	Flush(UINT8 uFlag = 0);
};

lsrErr GetEachNode(const void *pRoot);