///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//

#ifndef _JS_FUNCTIONS_H
#define _JS_FUNCTIONS_H

#include "stdafx.h"

#define XP_WIN
#include "jsapi.h"


JSBool	SetElementProperties(JSContext *ctx, JSObject *obj, jsval *jsElement);

JSBool	InitClass(JSContext *ctx, JSObject **obj, JSFunctionSpec *afuncA);
JSBool	GetAttrValue(JSContext *ctx, void *pElement, TCHAR *szParam, jsval *rval);
JSBool	SetAttrValue(JSContext *ctx, void *pElement, jsval *argv);

JSBool	JGetTarget(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

JSBool	JAppendChild(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JGetAttribute(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JGetOwnerDocument(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JGetStyle(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JRemoveChild(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JSetAttribute(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

JSBool	JCreateElement(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JGetDocumentElement(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JGetElementById(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

JSBool	JGetPropertyValue(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool	JSetProperty(JSContext *ctx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

#endif