///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PlayerStatusbar.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPlayerStatusbar dialog

#include "Label.h"

#define STATUSMODE_IDLE         0
#define STATUSMODE_LOCALMEDIA   1
#define STATUSMODE_NETMEDIA     2
#define STATUSMODE_BUFFERING    3
#define STATUSMODE_FAILED       4


class CPlayerStatusbar : public CDialogBar
{
// Construction
public:
	CPlayerStatusbar(CWnd* pParent = NULL);		// standard constructor

	void	SetMessage(CString strMessage);
	void	SetTime(UINT64 uCurTime);
	void	SetDuration(INT64 nDuration);

	void	SetStatusMode(UINT8 nMode);
	void	SetAudioMode(INT8 nMode);

	void	Reset();

	void	StopBuffering();

protected:
	CStatic	m_IconStatus, m_IconSpeakerL, m_IconSpeakerR;
	HICON	m_hIconStatus, m_hIconSpeakerL, m_hIconSpeakerR;

	CLabel	m_StatusLabel;
	CLabel	m_TimerLabel;
	int		m_nTimeDisplayMode;
	int		m_nAudioMode;
	int		m_nFlipInfoCounter;
	CString	m_strFlipInfo0, m_strFlipInfo1, m_strFlipInfo2, m_strFlipInfo3, m_strFlipInfo4;
	CString	m_strDuration;

	int		m_nBufferingCounter;

	BOOL	InitDialogBar();

	void	DoFlipInfo();

	void	DoBuffering();

	void	Relayout();

	void	SetStatusIcon(WORD wIcon);
	void	SetSpeakerLIcon(WORD wIcon);
	void	SetSpeakerRIcon(WORD wIcon);

	void	SetStatusIcon2(HICON hIcon);
	void	SetSpeakerLIcon2(HICON hIcon);
	void	SetSpeakerRIcon2(HICON hIcon);

public:
// Dialog Data
	//{{AFX_DATA(CPlayerStatusbar)
	enum { IDD = IDD_PLAYER_STATUSBAR };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlayerStatusbar)
	public:
	virtual BOOL Create(CWnd *pParentWnd, UINT nIDTemplate, UINT nStyle, UINT nID);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPlayerStatusbar)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};