///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//

#if !defined(AFX_PLAYLISTDLG_H__511E3294_FE95_4819_94D6_1F22D2665790__INCLUDED_)
#define AFX_PLAYLISTDLG_H__511E3294_FE95_4819_94D6_1F22D2665790__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PlaylistDlg.h : header file
//

#include "DragAndDropListBox.h"

/////////////////////////////////////////////////////////////////////////////
// CPlaylistDlg dialog

class CPlaylistDlg : public CDialog
{
// Construction
public:
	CPlaylistDlg(CWnd* pParent = NULL);   // standard constructor

	CDragAndDropListBox m_clsListboxPlaylist;

	void	GetFileToPlay(CString &strFileToPlay);
	INT8	RequestNextFile();
	INT8	RequestPreviousFile();
	INT8	RewindPlayList();

	int		AddPlayListEntry(CString strEntry);

	void	DoPlayListRemove();
	void	DoPlayListRemoveAll();
	void	DoPlayListAdd();
	void	DoPlayListPlay();

	void	LoadPlayList(CString strFileName);
	void	SavePlayList(CString strFileName);

	void	PlayFromFirst();
	void	DoPlaylistSort();

	afx_msg void OnDropFiles(HDROP hDropInfo);

private:
	CString	m_strFileToPlay;
	UINT	m_uCurrentPlayIndex;

protected:
	void	SetExtendListbox();

public:
// Dialog Data
	//{{AFX_DATA(CPlaylistDlg)
	enum { IDD = IDD_PLAYLIST };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlaylistDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPlaylistDlg)
	virtual void	OnOK();
	virtual BOOL	OnInitDialog();
	afx_msg void	OnDblclkListPlaylist();
	afx_msg void	OnButtonPlAdd();
	afx_msg void	OnButtonPlRemove();
	afx_msg void	OnButtonPlRemoveall();
	afx_msg void	OnButtonPlStartplay();
	afx_msg void	OnButtonPlLoad();
	afx_msg void	OnButtonPlSave();
	afx_msg void	OnButtonPlSort();
	//}}AFX_MSG

	virtual void	OnCancel();

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYLISTDLG_H__511E3294_FE95_4819_94D6_1F22D2665790__INCLUDED_)
