///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//

// ProgressDlgBar.cpp : implementation file
//

#include "stdafx.h"
#include "LASeRPlayer.h"
#include "ProgressDlgBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressDlgBar dialog


CProgressDlgBar::CProgressDlgBar(CWnd* pParent /*=NULL*/)
	: CDialogBar(/*CProgressDlgBar::IDD, pParent*/)
{
	//{{AFX_DATA_INIT(CProgressDlgBar)
	//}}AFX_DATA_INIT
}


void CProgressDlgBar::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDlgBar)
	DDX_Control(pDX, IDC_SLIDER_PROGRESS, m_clsSliderProgress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgressDlgBar, CDialogBar)
	//{{AFX_MSG_MAP(CProgressDlgBar)
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressDlgBar message handlers

BOOL CProgressDlgBar::Create(CWnd *pParentWnd, UINT nIDTemplate, UINT nStyle, UINT nID) 
{
	BOOL bRes = CDialogBar::Create(pParentWnd,nIDTemplate,nStyle,nID);

	InitDialogBar();

	return bRes;
}

BOOL CProgressDlgBar::InitDialogBar(void)
{
	UpdateData(FALSE);

	// init the slider progress
	m_clsSliderProgress.SetLineSize(1);
	m_clsSliderProgress.SetPageSize(10);
	m_clsSliderProgress.SetRange(0, 100);
	m_clsSliderProgress.SetPos(0);

	return TRUE;
}

void CProgressDlgBar::OnSize(UINT nType, int cx, int cy) 
{
	CDialogBar::OnSize(nType, cx, cy);

	if (GetDlgItem(IDC_SLIDER_PROGRESS) != NULL)
		GetDlgItem(IDC_SLIDER_PROGRESS)->MoveWindow(0, 0, cx, 21);
}

void CProgressDlgBar::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if ((CSliderCtrl*)pScrollBar == (CSliderCtrl*)GetDlgItem(IDC_SLIDER_PROGRESS))
	{
		// only handle SB_THUMBPOSITION message
		// Up/Down, Home/End,  PageUp/Down on CSliderCtrl will send message also
		if (nSBCode == SB_THUMBPOSITION)
		{
			int nSliderPos = m_clsSliderProgress.GetPos();
			AfxGetApp()->m_pMainWnd->PostMessage(UWM_SLIDER_PROGRESS, nSliderPos, 0);
		}
	}

	CDialogBar::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CProgressDlgBar::SetSliderProgress(UINT8 uPos)
{
	if (GetDlgItem(IDC_SLIDER_PROGRESS) != NULL)
	{
		if ((uPos < 0) || (uPos > 100))
			uPos = 0;

		m_clsSliderProgress.SetPos(uPos);
	}
}

void CProgressDlgBar::EnableProgressBar(UINT8 bEnable)
{
	m_clsSliderProgress.SetEnable(bEnable);
}