///////////////////////////////////////////////////////////////////////////////
//
//  This software module was originally developed by SAMSUNG ELECTRONICS CO., LTD.
// and Kyunghee University, Korea in the course of development of the ISO/IEC 
// 14496-20(Lightweight Application Scene Representation -LASeR- and Simple 
// Aggregation Format -SAF-) AMD2: Adaptation standard for reference purposes and
// its performance may not have been optimized.
//
// This software module is an implementation of one or more tools as specified by 
// the ISO/IEC 14496-20 AMD2: Adaptation standard.
//
// ISO/IEC gives users free license to this software module or modifications 
// thereof for use in hardware or software products claiming conformance to 
// audiovisual and image-coding related ITU Recommendations and/or ISO/IEC
// International Standards.
//
// ISO/IEC gives users the same free license to this software module or 
// modifications thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in hardware or software products are
// advised that its use may infringe existing patents. 
//
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
//

// Implementation of general functions

#include "stdafx.h"
#include "functions.h"


// Get the operating system's major version
// Return values:
//  int  : os major version
UINT8 OS_GetMajorVersion()
{
  OSVERSIONINFO osvi;

  ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
  osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

  GetVersionEx(&osvi);

  return osvi.dwMajorVersion;
}


CTimeSplitter::CTimeSplitter()
{
	m_uHours	= 0;
	m_uMinutes	= 0;
	m_uSeconds	= 0;
	m_uTime	= 0;
}

CTimeSplitter::~CTimeSplitter()
{
}

void CTimeSplitter::SetTime(UINT64 uTime)
{
	m_uTime = uTime;

	m_uHours	= (UINT8)(m_uTime / 3600);
	m_uMinutes	= (UINT8)((m_uTime - m_uHours * 3600) / 60);
	m_uSeconds	= (UINT8)(m_uTime - m_uHours * 3600 - m_uMinutes * 60);
}

UINT8 CTimeSplitter::GetHours() const
{
	return m_uHours;
}

UINT8 CTimeSplitter::GetMinutes() const
{
	return m_uMinutes;
}

UINT8 CTimeSplitter::GetSeconds() const
{
	return m_uSeconds;
}