#include "laser_error.h"
#include "..\LASeR.h"
#include "..\Datatypes.h"


CStringIDTable::CStringIDTable()
{
	CLASeRUnit::CLASeRUnit();

	m_uElementType	= LSR_StringIDTable;
}

CStringIDTable::~CStringIDTable()
{
	m_astrStrings.clear();
}

/************************************************************************/
// SetAttribute
// Desc		: function of 'StringIDTable' to set the children elements or the attributes
// Param	: DOM tree
// History
//	PSH (2008. 8. 17)	- first release
/************************************************************************/
lsrErr CStringIDTable::SetAttributes(LPXNode pScene)
{
	lsrErr err = LASeRNoErr;

	const TCHAR	*szTemp	= NULL;

	/************************************************************************/
	// set attribute
	// strings
	szTemp = pScene->GetAttrValue(_T("strings"));
	if (szTemp)
	{
		m_astrStrings = ReadStringListType(szTemp, _T(' '), &err);
		CONFIRM(err);
	}

	if (m_astrStrings.size() == 0)
		err = LASeRValidationErr;

	return err;
}